# ScreenSaver

This is a "screensaver" program written in AMOS Pro 2.0.

## Description

Years ago (around 2006) I got an extra winter break assignment for my
programming classes - write a DOS graphics mode screensaver in Turbo Pascal.
That code has since been lost, unfortunately.

During Christmas break 2020, I was working on putting my Amiga 1200 back
together and needed a way to put her through her paces to ensure her stability.
I settled for an AMOS Pro 2.0 programming recreating that lost program to the
best of my recollection.

It took me around 8h to write the program on my Amiga. I last touched AMOS
Pro 2.0 over 20o years ago, so I needed some time get used to it again. Also,
programming graphics on Amiga (or any other system for that matter) isn't my
usual glass of beer, so I had to experiment to make things work (kinda) like I
wanted them to. It's not like you can find an answer to _Why the hell double
buffering doesn't work in AMOS?_ on Stack Overflow in 2020 ;). I got it
working, had some fun with it and gave my Miggy a good shakedown.

I tested the program on my machine (AGA, 68030 @ 25MHz, 128MB Fast RAM) and on
emulated bare Amiga 500 (OCS, 68000 @ 7MHz, 0.5MB Chip RAM). It works, so I
declare it done.

## Live Demo

You can see the program running on an emulated Amiga 500
[here](https://www.youtube.com/watch?v=0UcZrYuE1-g).

## Contents of this repository:

* `ScreenSaver.adf` - a bootable ADF that launches the program from the
  startup-sequence. Ready for writing to a floppy (or a Gotek flash drive) or
  using in an emulator.
* `ScreenSaver.AMOS` - AMOS Pro 2.0 source file.
* `ScreenSaver.AMOS.txt` - TXT printout AMOS Pro 2.0 source file.
* `ScreenSaver.exe` - the compiled program. Ready to run from CLI.

## Contributing

If you think you found a bug or want to send a patch, feel free to contact
me through e-mail.

## Author

ScreenSaver is developed by [Tomek Wójcik](https://www.bthlabs.pl/).

## License

ScreenSaver is licensed under the MIT License.
